package org.zeroturnaround.javarebel.integration.servlet.weblogic;

import org.zeroturnaround.bundled.javassist.CannotCompileException;
import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.bundled.javassist.expr.ExprEditor;
import org.zeroturnaround.bundled.javassist.expr.MethodCall;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>weblogic.servlet.internal.WebAppConfigManager<code>
 * to enable JSP updates in production mode.
 * 
 * @author Rein Raudjärv
 * 
 * @see JspConfigCBP
 */
public class WebAppConfigManagerCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    try {
      CtMethod m = ctClass.getDeclaredMethod("getResourceReloadCheckSecs");
      m.instrument(new ExprEditor() {
        public void edit(MethodCall m) throws CannotCompileException {
          if (m.getClassName().equals("weblogic.servlet.internal.HttpServer")
              && m.getMethodName().equals("isProductionModeEnabled"))
            m.replace("{ $_ = false; }");
        }
      });
    } catch (NotFoundException e) {
      // skip
    }
  }

}
