package org.zeroturnaround.javarebel.integration.servlet.websphere;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>com.ibm.ws.jsp.JspOptions</code>.
 * 
 * @author Rein Raudjärv
 */
public class JspOptionsCBP extends JavassistClassBytecodeProcessor {
  
  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    // Override JSP reloading interval to be 1 second
    try {
      CtMethod m = ctClass.getDeclaredMethod("getReloadInterval");
      m.setBody("{ return 1000L; }");
    } catch (NotFoundException e) {
    }
  }
}
